Loading...
Searching...
No Matches
pcl::octree::PointCoding< PointT > Class Template Reference

PointCoding class More...

`#include <pcl/compression/point_coding.h>`

## Public Member Functions

| PointCoding ()=default
| Constructor.
virtual | ~PointCoding ()=default
| Empty class constructor.
void | setPrecision (float precision_arg)
| Define precision of point information.
float | getPrecision ()
| Retrieve precision of point information.
void | setPointCount (unsigned int pointCount_arg)
| Set amount of points within point cloud to be encoded and reserve memory.
void | initializeEncoding ()
| Initialize encoding of differential point.
void | initializeDecoding ()
| Initialize decoding of differential point.
std::vector< char > & | getDifferentialDataVector ()
| Get reference to vector containing differential color data.
void | encodePoints (const Indices &indexVector_arg, const double *referencePoint_arg, PointCloudConstPtr inputCloud_arg)
| Encode differential point information for a subset of points from point cloud.
void | decodePoints (PointCloudPtr outputCloud_arg, const double *referencePoint_arg, uindex_t beginIdx_arg, uindex_t endIdx_arg)
| Decode differential point information.

## Protected Attributes

PointCloudPtr | output_ {nullptr}
| Pointer to output point cloud dataset.
std::vector< char > | pointDiffDataVector_
| Vector for storing differential point information.
std::vector< char >::const_iterator | pointDiffDataVectorIterator_
| Iterator on differential point information vector.
float | pointCompressionResolution_ {0.001f}
| Precision of point coding.

## Detailed Description

template<typename PointT>
class pcl::octree::PointCoding< PointT >

PointCoding class

Note
  This class encodes 8-bit differential point information for octree-based point cloud compression.
  typename: PointT: type of point used in pointcloud

Author
  Julius Kammerl (juliu.nosp@m.s@ka.nosp@m.mmerl.nosp@m..de)

Definition at line 54 of file point_coding.h.

## Constructor & Destructor Documentation

## PointCoding()

template<typename PointT>

pcl::octree::PointCoding< PointT >::PointCoding | ( |  | ) |

default

Constructor.

## ~PointCoding()

template<typename PointT>

virtual pcl::octree::PointCoding< PointT >::~PointCoding | ( |  | ) |

virtual default

Empty class constructor.

## Member Function Documentation

## decodePoints()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::decodePoints | ( | PointCloudPtr | outputCloud_arg,
|  | const double * | referencePoint_arg,
|  | uindex_t | beginIdx_arg,
|  | uindex_t | endIdx_arg )

inline

Decode differential point information.

Parameters

  outputCloud_arg | output point cloud
  referencePoint_arg | coordinates of reference point
  beginIdx_arg | index indicating first point to be assigned with color information
  endIdx_arg | index indicating last point to be assigned with color information

Definition at line 153 of file point_coding.h.

References pointCompressionResolution_, and pointDiffDataVectorIterator_.

## encodePoints()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::encodePoints | ( | const Indices & | indexVector_arg,
|  | const double * | referencePoint_arg,
|  | PointCloudConstPtr | inputCloud_arg )

inline

Encode differential point information for a subset of points from point cloud.

Parameters

  indexVector_arg | indices defining a subset of points from points cloud
  referencePoint_arg | coordinates of reference point
  inputCloud_arg | input point cloud

Definition at line 123 of file point_coding.h.

References pointCompressionResolution_, and pointDiffDataVector_.

## getDifferentialDataVector()

template<typename PointT>

std::vector< char > & pcl::octree::PointCoding< PointT >::getDifferentialDataVector | ( |  | ) |

inline

Get reference to vector containing differential color data.

Definition at line 112 of file point_coding.h.

References pointDiffDataVector_.

## getPrecision()

template<typename PointT>

float pcl::octree::PointCoding< PointT >::getPrecision | ( |  | ) |

inline

Retrieve precision of point information.

Returns
  precision

Definition at line 82 of file point_coding.h.

References pointCompressionResolution_.

## initializeDecoding()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::initializeDecoding | ( |  | ) |

inline

Initialize decoding of differential point.

Definition at line 105 of file point_coding.h.

References pointDiffDataVector_, and pointDiffDataVectorIterator_.

## initializeEncoding()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::initializeEncoding | ( |  | ) |

inline

Initialize encoding of differential point.

Definition at line 98 of file point_coding.h.

References pointDiffDataVector_.

## setPointCount()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::setPointCount | ( | unsigned int | pointCount_arg | ) |

inline

Set amount of points within point cloud to be encoded and reserve memory.

Parameters

  pointCount_arg | amounts of points within point cloud

Definition at line 91 of file point_coding.h.

References pointDiffDataVector_.

## setPrecision()

template<typename PointT>

void pcl::octree::PointCoding< PointT >::setPrecision | ( | float | precision_arg | ) |

inline

Define precision of point information.

Parameters

  precision_arg | precision

Definition at line 73 of file point_coding.h.

References pointCompressionResolution_.

## Member Data Documentation

## output_

template<typename PointT>

PointCloudPtr pcl::octree::PointCoding< PointT >::output_ {nullptr}

protected

Pointer to output point cloud dataset.

Definition at line 180 of file point_coding.h.

## pointCompressionResolution_

template<typename PointT>

float pcl::octree::PointCoding< PointT >::pointCompressionResolution_ {0.001f}

protected

Precision of point coding.

Definition at line 189 of file point_coding.h.

Referenced by decodePoints(), encodePoints(), getPrecision(), and setPrecision().

## pointDiffDataVector_

template<typename PointT>

std::vector<char> pcl::octree::PointCoding< PointT >::pointDiffDataVector_

protected

Vector for storing differential point information.

Definition at line 183 of file point_coding.h.

Referenced by encodePoints(), getDifferentialDataVector(), initializeDecoding(), initializeEncoding(), and setPointCount().

## pointDiffDataVectorIterator_

template<typename PointT>

std::vector<char>::const_iterator pcl::octree::PointCoding< PointT >::pointDiffDataVectorIterator_

protected

Iterator on differential point information vector.

Definition at line 186 of file point_coding.h.

Referenced by decodePoints(), and initializeDecoding().

The documentation for this class was generated from the following file:

- pcl/compression/point_coding.h